	CHARACTER*(*) FUNCTION LEGAL_CHARS( string, leg_len )

*
*
*  This software was developed by the Thermal Modeling and Analysis
*  Project(TMAP) of the National Oceanographic and Atmospheric
*  Administration's (NOAA) Pacific Marine Environmental Lab(PMEL),
*  hereafter referred to as NOAA/PMEL/TMAP.
*
*  Access and use of this software shall impose the following
*  obligations and understandings on the user. The user is granted the
*  right, without any fee or cost, to use, copy, modify, alter, enhance
*  and distribute this software, and any derivative works thereof, and
*  its supporting documentation for any purpose whatsoever, provided
*  that this entire notice appears in all copies of the software,
*  derivative works and supporting documentation.  Further, the user
*  agrees to credit NOAA/PMEL/TMAP in any publications that result from
*  the use of this software or in any product that includes this
*  software. The names TMAP, NOAA and/or PMEL, however, may not be used
*  in any advertising or publicity to endorse or promote any products
*  or commercial entity unless specific written permission is obtained
*  from NOAA/PMEL/TMAP. The user also understands that NOAA/PMEL/TMAP
*  is not obligated to provide the user with any support, consulting,
*  training or assistance of any kind with regard to the use, operation
*  and performance of this software nor to provide the user with any
*  updates, revisions, new versions or "bug fixes".
*
*  THIS SOFTWARE IS PROVIDED BY NOAA/PMEL/TMAP "AS IS" AND ANY EXPRESS
*  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
*  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL NOAA/PMEL/TMAP BE LIABLE FOR ANY SPECIAL,
*  INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
*  RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
*  CONTRACT, NEGLIGENCE OR OTHER TORTUOUS ACTION, ARISING OUT OF OR IN
*  CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE. 
*
*
* remove all non-character (non-digit) data from a string - return final length

* programmer - steve hankin
* NOAA/PMEL, Seattle, WA - Tropical Modeling and Analysis Program
* written for VAX computer under VMS operating system
*
* revision 0.0 - 9/26/87

        IMPLICIT NONE
* calling argument declarations
	CHARACTER*(*)	string
	INTEGER		leg_len

* local variable declarations:
	INTEGER TM_LENSTR, mlen, slen, s
	CHARACTER char1*1

* initialize
	slen	= TM_LENSTR( string )
	mlen	= LEN( LEGAL_CHARS )
	leg_len	= 0

* loop through input string character by character
	DO 100 s = 1, slen
	   char1 = string(s:s)
	   IF ( char1 .GE. '0' .AND. char1 .LE. '9'
     .	   .OR. char1 .GE. 'A' .AND. char1 .LE. 'Z'
     .	   .OR. char1 .GE. 'a' .AND. char1 .LE. 'z' ) THEN
	      leg_len = leg_len + 1
	      LEGAL_CHARS( leg_len:leg_len ) = char1
	      IF ( leg_len .EQ. mlen ) RETURN
	   ENDIF
 100	CONTINUE

	RETURN
	END
